ucasFL translating
Top 10 open source projects of 2016
============================================================

### In our annual list of the year's top open source projects, we look back at popular projects our writers covered in 2016, plus favorites our Community Moderators picked.

 ![Top 10 open source projects of 2016](https://opensource.com/sites/default/files/styles/image-full-size/public/images/law/bowling-10-ten-520_cc.png?itok=Jd1FYLWt "Top 10 open source projects of 2016")

Image by : [George Eastman House][1] and [Internet Archive Book Images][2]. Modified by Opensource.com. CC BY-SA 4.0

We continue to be impressed with the wonderful open source projects that emerge, grow, change, and evolve every year. Picking 10 to include in our annual list of top projects is no small feat, and certainly no list this short can include every deserving project.

To choose our 10, we looked back at popular open source projects our writers covered in 2016, and collected suggestions from our Community Moderators. After a round of nominations and voting by our moderators, our editorial team narrowed down the final list.

So here they are, our top 10 open source projects of 2016:

### Atom

[Atom][3] is a hackable text editor from GitHub. Jono Bacon [wrote][4] about its "simple core" earlier this year, exclaiming approval for open source projects that give users options.

"[Atom] delivers the majority of the core features and settings that most users likely will want, but is missing many of the more advanced or specific features some users may want. … Atom provides a powerful framework that allows pretty much any part of Atom to be changed and expanded."

To get started contributing, read the [guide][5]. To connect with other users and the community, find Atom on [GitHub][6], [Discuss][7], and [Slack][8].

Atom is [MIT][9] licensed and the [source code][10] is hosted on GitHub.

### Eclipse Che

[Eclipse Che][11] is a next-generation online integrated development environment (IDE) and developer workspace. Joshua Allen Holm brought us a [review][12] of Eclipse Che in November 2016, which provided a look at the developer community behind the project, its innovative use of container technology, and popular languages it supports out of the box.

"The ready-to-go bundled stacks included with Eclipse Che cover most of the modern popular languages. There are stacks for C++, Java, Go, PHP, Python, .NET, Node.js, Ruby on Rails, and Android development. A Stack Library provides even more options and if that is not enough, there is the option to create a custom stack that can provide specialized environments."

You can test out Eclipse Che in an online [hosted account][13], through a [local installation][14], or in your preferred [cloud provider][15]. The [source code][16] can be found on GitHub under an [Eclipse Public License][17].

### FreeCAD

[FreeCAD][18] is written in Python and one of the many computer-aided design—or computer-aided drafting—tools available to create design specifications for real-world objects. Jason Baker wrote about FreeCAD in [3 open source alternatives to AutoCAD][19].

"FreeCAD can import and export from a variety of common formats for 3D objects, and its modular architecture makes it easy to extend the basic functionality with various plug-ins. The program has many built-in interface options, from a sketcher to renderer to even a robot simulation ability."

FreeCAD is [LGPL][20] licensed and the [source code][21] is hosted on GitHub.

### GnuCash

[GnuCash][22] is a cross-platform open source desktop solution for managing your personal and small business accounts. Jason Baker included GnuCash in our [roundup][23] of the open source alternatives to Mint and Quicken for personal finance.

GnuCash "features multi-entry bookkeeping, can import from a wide range of formats, handles multiple currencies, helps you create budgets, prints checks, creates custom reports in Scheme, and can import from online banks and pull stock quotes for you directly."

You can find GnuCash's [source code][24] on GitHub under a GPL [version 2 or 3 license][25].

An honorable mention goes to GnuCash alternative [KMyMoney][26], which also received a nomination for our list, and is another great option for keeping your finances in Linux.

### Kodi

[Kodi][27] is an open source media center solution, formerly known as XBMC, which works on a variety of devices as a do-it-yourselfer's tool to building a set-top box for playing movies, TV, music, and more. It is heavily customizable, and supports numerous skins, plugins, and a variety of remote control devices (including its own custom Android remote for your phone).

Although we didn't cover Kodi in-depth this year, it kept popping up in articles on building a home Linux [music server][28], media [management tools][29], and even a previous poll on favorite open source [video players][30]. (If you're using Kodi at home and want to write about your experience, [let us know][31].)

The [source code][32] to Kodi can be found on GitHub under a [GPLv2][33] license.

### MyCollab

[MyCollab][34] is a suite of tools for customer relationship management, document management, and project management. Community Moderator Robin Muilwijk covered the details of the project management tool MyCollab-Project in his roundup of [Top 11 project management tools for 2016][35].

"MyCollab-Project includes many features, like a Gantt chart and milestones, time tracking, and issue management. It also supports agile development models with its Kanban board. MyCollab-Project comes in three editions, of which the [community edition][36] is the free and open source option."

Installing MyCollab requires a Java runtime and MySQL stack. Visit the [MyCollab site][37] to learn how to contribute to the project.

MyCollab is AGPLv3 licensed and the [source code][38] is hosted on GitHub.

### OpenAPS

[OpenAPS][39] is another project that our moderators found interesting in 2016, but also one that we have yet to cover in depth. OpenAPS, the Open Artificial Pancreas System project, is an open source project devoted to improving the lives of people with Type 1 diabetes.

The project includes "[a safety-focused reference design,][40] a[ toolset][41], and an open source [reference implementation][42]" designed for device manufacturers or any individual to be able to build their own artificial pancreas device to be able to safely regulate blood glucose levels overnight by adjusting insulin levels. Although potential users should examine the project carefully and discuss it with their healthcare provider before trying to build or use the system themselves, the project founders hope opening up technology will accelerate the research and development pace across the medical devices industry to discover solutions and bring them to market even faster.

### OpenHAB

[OpenHAB][43] is a home automation platform with a pluggable architecture. Community Moderator D Ruth Bavousett [wrote][44] about OpenHAB after buying a home this year and trying it out.

"One of the interesting modules I found was the Bluetooth binding; it can watch for the presence of specific Bluetooth-enabled devices (your smartphone, and those of your children, for instance) and take action when that device arrives or leaves—lock or unlock doors, turn on lights, adjust your thermostat, turn off security modes, and so on."

Check out the [full list of binding and bundles][45] that provide integration and communication with social networks, instant messaging, cloud IoT platforms, and more.

OpenHAB is EPL licensed and the [source code][46] is hosted on GitHub.

### OpenToonz

[OpenToonz][47] is production software for 2D animation. Community Moderator Joshua Allen Holm [reported][48] on its open source release in March 2016, and it has been mentioned in other animation-related articles on Opensource.com, but we haven't covered it in depth. Stay tuned for that.

In the meantime, we can tell you that there are a number of features unique to OpenToonz, including GTS, which is a spanning tool developed by Studio Ghibli, and [a plug-in effect SDK][49] for image processing.

To discuss development and video research topics, check out the [forum][50] on GitHub. OpenToonz [source code][51] is hosted on GitHub and the project is licensed under a modified BSD license.

### Roundcube

[Roundcube][52] is a modern, browser-based email client that provides much—if not all—of the functionality email users may be used to with a desktop client. Featuring support for more than 70 languages, integrated spell-checking, a drag-and-drop interface, a feature-rich address book, HTML email composition, multiple search features, PGP encryption support, threading, and more, Roundcube can work as a drop-in replacement email client for many users.

Roundcube was included along with four other solutions in our roundup of open source [alternatives to Gmail][53].

You can find the [source code][54] to Roundcube on GitHub under a [GPLv3][55] license. In addition to [downloading][56] and installing the project directly, you can also find it inside many complete email server packages, including [Kolab Groupware][57], [iRedMail][58], [Mail-in-a-Box][59], and [mailcow][60].

--------------------------------------------------------------------------------

作者简介：

![](https://opensource.com/sites/default/files/styles/profile_pictures/public/jen-headshot-square.jpeg?itok=GTMugLtD)

Jen Wike Huger - Jen Wike Huger is the Content Manager for Opensource.com. She manages the publication calendar, coordinates the editing team, and guides new and current writers. Follow her on Twitter @jenwike, and see her extended portfolio at Jen.io.

--------------------------------------------------------------------------------

via: https://opensource.com/article/16/12/yearbook-top-10-open-source-projects

作者：[Jen Wike Huger ][a]
译者：[译者ID](https://github.com/译者ID)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/jen-wike
[1]:https://www.flickr.com/photos/george_eastman_house/
[2]:https://www.flickr.com/photos/internetarchivebookimages/14784547612/in/photolist-owsEVj-odcHUi-osAjiE-x91Jr9-obHow3-owt68v-owu56t-ouySJt-odaPbp-owajfC-ouBSeL-oeTzy4-ox1okT-odZmpW-ouXBnc-ot2Du4-ocakCh-obZ8Pp-oeTNDK-ouiMZZ-ie12mP-oeVPhH-of2dD4-obXM65-owkSzg-odBEbi-oqYadd-ouiNiK-icoz2G-ie4G4G-ocALsB-ouHTJC-wGocbd-osUxcE-oeYNdc-of1ymF-idPbwn-odoerh-oeSekw-ovaayH-otn9x3-ouoPm7-od8KVS-oduYZL-obYkk3-hXWops-ocUu6k-dTeHx6-ot6Fs5-ouXK46
[3]:https://atom.io/
[4]:https://opensource.com/life/16/2/culture-pluggable-open-source
[5]:https://github.com/atom/atom/blob/master/CONTRIBUTING.md
[6]:https://github.com/atom/atom
[7]:http://discuss.atom.io/
[8]:http://atom-slack.herokuapp.com/
[9]:https://raw.githubusercontent.com/atom/atom/master/LICENSE.md
[10]:https://github.com/atom/atom
[11]:http://www.eclipse.org/che/
[12]:https://opensource.com/life/16/11/introduction-eclipse-che
[13]:https://www.eclipse.org/che/getting-started/cloud/
[14]:https://www.eclipse.org/che/getting-started/download/
[15]:https://bitnami.com/stack/eclipse-che
[16]:https://github.com/eclipse/che/
[17]:https://github.com/eclipse/che/blob/master/LICENSE
[18]:http://www.freecadweb.org/
[19]:https://opensource.com/alternatives/autocad
[20]:https://github.com/FreeCAD/FreeCAD/blob/master/COPYING
[21]:https://github.com/FreeCAD/FreeCAD
[22]:https://www.gnucash.org/
[23]:https://opensource.com/life/16/1/3-open-source-personal-finance-tools-linux
[24]:https://github.com/Gnucash/
[25]:https://github.com/Gnucash/gnucash/blob/master/LICENSE
[26]:https://kmymoney.org/
[27]:https://kodi.tv/
[28]:https://opensource.com/life/16/1/how-set-linux-based-music-server-home
[29]:https://opensource.com/life/16/6/tinymediamanager-catalogs-your-movie-and-tv-files
[30]:https://opensource.com/life/15/11/favorite-open-source-video-player
[31]:https://opensource.com/how-submit-article
[32]:https://github.com/xbmc/xbmc
[33]:https://github.com/xbmc/xbmc/blob/master/LICENSE.GPL
[34]:https://community.mycollab.com/
[35]:https://opensource.com/business/16/3/top-project-management-tools-2016
[36]:https://github.com/MyCollab/mycollab
[37]:https://community.mycollab.com/docs/developing-mycollab/how-can-i-contribute-to-mycollab/
[38]:https://github.com/MyCollab/mycollab
[39]:https://openaps.org/
[40]:https://openaps.org/reference-design
[41]:https://github.com/openaps/openaps
[42]:https://github.com/openaps/oref0/
[43]:http://www.openhab.org/
[44]:https://opensource.com/life/16/4/automating-your-home-openhab
[45]:http://www.openhab.org/features/supported-technologies.html
[46]:https://github.com/openhab/openhab
[47]:https://opentoonz.github.io/e/index.html
[48]:https://opensource.com/life/16/3/weekly-news-march-26
[49]:https://github.com/opentoonz/plugin_sdk
[50]:https://github.com/opentoonz/opentoonz/issues
[51]:https://github.com/opentoonz/opentoonz
[52]:https://roundcube.net/
[53]:https://opensource.com/alternatives/gmail
[54]:https://github.com/roundcube/roundcubemail
[55]:https://github.com/roundcube/roundcubemail/blob/master/LICENSE
[56]:https://roundcube.net/download/
[57]:http://kolab.org/
[58]:http://www.iredmail.org/
[59]:https://mailinabox.email/
[60]:https://mailcow.email/
